package com.vendor.loader.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.loader.Log.Log;
import com.vendor.loader.Messages;
import com.vendor.loader.controler.Builder;
import com.vendor.loader.controler.GlobleControler;
import com.vendor.loader.struct.CableMode;
import com.vendor.loader.struct.CodeDownloadDescriptor;
import com.vendor.loader.struct.DbFrontEnd;
import com.vendor.loader.struct.DeliverySysDescriptor;
import com.vendor.loader.struct.DownloadMode;
import com.vendor.loader.struct.HeadTsPacket;
import com.vendor.loader.struct.LoaderDatagramData;
import com.vendor.loader.struct.LoaderDownloadControl;
import com.vendor.loader.struct.LoaderDownloadInfo;
import com.vendor.loader.struct.LoaderDownloadPartitionControl;
import com.vendor.loader.struct.LoaderDownloadPartitionControlInfoFlash;
import com.vendor.loader.struct.LoaderDownloadPartitionModeFlash;
import com.vendor.loader.struct.LoaderPartDesc;
import com.vendor.loader.struct.NetworkNameDescriptor;
import com.vendor.loader.struct.NitSection;
import com.vendor.loader.struct.PartFile;
import com.vendor.loader.struct.SectionHead;
import com.vendor.loader.struct.UpgradeFileInfo;
import com.vendor.loader.struct.UpgradeInfo;
import com.vendor.loader.struct.ssu.SsuUpgradeInfo;
import com.vendor.loader.util.Crc32;
import com.vendor.loader.util.FileHelper;
import com.vendor.loader.util.FileUtil;
import com.vendor.loader.util.LoaderException;
import com.vendor.loader.util.PropertiesUtility;
import com.vendor.loader.util.RandomFileOutputStream;
import com.vendor.loader.util.ssu.SsuPackageOptions;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStream;
import java.io.RandomAccessFile;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.SubProgressMonitor;
import org.eclipse.ui.WorkbenchEncoding;

public class SOCTTsPackageBuilder implements Builder {
  public static final String UPGRADE_FILE_NAME = "packer.ts";
  
  private static boolean TOTAL_DATA_CRC_ENBALE = true;
  
  private static final int SIZE_OF_U16 = 2;
  
  public static final int MAGICNUM_SIZE = 4;
  
  private static DownloadMode enDownloadMode = DownloadMode.MODE_FLASH;
  
  private static long g_u32DataTotleLen = 0L;
  
  private static int g_u32DataCrc = 0;
  
  private static long g_u32DataMagicNum = -1430532899L;
  
  private static int g_u16SecResvDataLen = 0;
  
  private static long g_appVersion = 16843009L;
  
  private static long g_softwareVersion = 16843009L;
  
  public static long getG_softwareVersion() {
    return g_softwareVersion;
  }
  
  public static void setG_softwareVersion(long g_softwareVersion) {
    com.vendor.loader.util.SOCTTsPackageBuilder.g_softwareVersion = g_softwareVersion;
  }
  
  private static long g_FactoryIdFlag = 3L;
  
  public static long getG_FactoryIdFlag() {
    return g_FactoryIdFlag;
  }
  
  public static void setG_FactoryIdFlag(long g_FactoryIdFlag) {
    com.vendor.loader.util.SOCTTsPackageBuilder.g_FactoryIdFlag = g_FactoryIdFlag;
  }
  
  private static long g_HardwareVersion = 1L;
  
  public static long getG_HardwareVersion() {
    return g_HardwareVersion;
  }
  
  public static void setG_HardwareVersion(long g_HardwareVersion) {
    com.vendor.loader.util.SOCTTsPackageBuilder.g_HardwareVersion = g_HardwareVersion;
  }
  
  private static long g_start_sn = 0L;
  
  public static long getG_start_sn() {
    return g_start_sn;
  }
  
  public static void setG_start_sn(long g_start_sn) {
    com.vendor.loader.util.SOCTTsPackageBuilder.g_start_sn = g_start_sn;
  }
  
  private static long g_end_sn = -1L;
  
  public static long getG_end_sn() {
    return g_end_sn;
  }
  
  public static void setG_end_sn(long g_end_sn) {
    com.vendor.loader.util.SOCTTsPackageBuilder.g_end_sn = g_end_sn;
  }
  
  private static long g_download_date = 537460993L;
  
  private static DbFrontEnd g_struFrontend;
  
  private static List<PartFile> partFiles;
  
  private static short partitionNum;
  
  private static boolean is32Bit;
  
  private static boolean is64Bit;
  
  public static DbFrontEnd getG_struFrontend() {
    return g_struFrontend;
  }
  
  public static void setG_struFrontend(DbFrontEnd g_struFrontend) {
    com.vendor.loader.util.SOCTTsPackageBuilder.g_struFrontend = g_struFrontend;
  }
  
  public static List<PartFile> getPartFiles() {
    return partFiles;
  }
  
  public static void setPartFiles(List<PartFile> partFiles) {
    com.vendor.loader.util.SOCTTsPackageBuilder.partFiles = partFiles;
  }
  
  public static short getPartitionNum() {
    return partitionNum;
  }
  
  public static void setPartitionNum(int partitionNum) {
    com.vendor.loader.util.SOCTTsPackageBuilder.partitionNum = (short)partitionNum;
  }
  
  public static void setIs32Bit(boolean is32Bit) {
    com.vendor.loader.util.SOCTTsPackageBuilder.is32Bit = is32Bit;
  }
  
  public static boolean isIs32Bit() {
    return is32Bit;
  }
  
  public static void set64Bit(boolean is64Bit) {
    com.vendor.loader.util.SOCTTsPackageBuilder.is64Bit = is64Bit;
  }
  
  public static boolean is64Bit() {
    return is64Bit;
  }
  
  private int count = 0;
  
  static byte[] tempSectionData = new byte[992];
  
  private byte[] tempByte = new byte[6144];
  
  private static long getRandomU32() {
    Random r = new Random(System.currentTimeMillis());
    int r1 = r.nextInt();
    int r2 = r.nextInt();
    long guid = (r1 & 0xFFFF | r2 << 16 & 0xFFFF0000);
    return guid;
  }
  
  private static int SEC_RESERVED_DATA_LEN() {
    return 2 + g_u16SecResvDataLen;
  }
  
  private static int putFourByte(int value, byte[] buffer, int offset) {
    buffer[offset] = (byte)((value & 0xFF000000) >>> 24);
    buffer[offset + 1] = (byte)((value & 0xFF0000) >>> 16);
    buffer[offset + 2] = (byte)((value & 0xFF00) >>> 8);
    buffer[offset + 3] = (byte)(value & 0xFF);
    return offset + 4;
  }
  
  public IStatus createPackage(List<UpgradeFileInfo> files, UpgradeInfo info, String strFilePathName, IProgressMonitor monitor) throws IOException, LoaderException {
    log("(SOCT TS package) start package...");
    monitor.setTaskName("Validate upgrade file list..");
    setIs32Bit(GlobleControler.intance.is32Bit());
    set64Bit(GlobleControler.intance.is64Bit());
    log("(SOCT TS package) is32Bit..." + is32Bit);
    log("(SOCT TS package) is64Bit..." + is64Bit);
    boolean success = FileHelper.validateUpdateFilesList(files, 503316480L);
    log("Validate result:\t" + success);
    if (!success)
      return Status.CANCEL_STATUS; 
    log("Analysis of the part file");
    monitor.setTaskName("Analysis of the part file");
    files = FileHelper.getRealBurnFileList(files, 503316480L);
    log("File number:" + files.size());
    if (256 < files.size())
      throw new LoaderException(String.format(Messages.LoaderComposite_MaxPartFile, new Object[] { Integer.valueOf(256) })); 
    monitor.beginTask("Packaged part files", 100 * files.size() + 20 + 20);
    setG_softwareVersion(info.getSoftwareVersion());
    setG_FactoryIdFlag(info.getManufacturerId());
    setG_HardwareVersion(info.getHardwareVersion());
    setG_start_sn(info.getStartSn());
    setG_end_sn(info.getEndSn());
    setG_struFrontend(new DbFrontEnd());
    getG_struFrontend().setU32Frequency(674000);
    getG_struFrontend().setU32SymbolRate(6875000);
    getG_struFrontend().setEnModulation(CableMode.valueOf(2));
    getG_struFrontend().setU16TsPID((short)info.getDownloadPid());
    getG_struFrontend().setU8TableID((byte)info.getDownloadTableId());
    monitor.worked(5);
    byte[] tsBuffer = new byte[184];
    int lenDatagram = 0;
    int lenPartInfo = 0;
    int lenDownloadCtrl = 0;
    int offset = 0;
    LoaderDownloadControl loaderControl = new LoaderDownloadControl();
    LoaderDownloadPartitionControl partitionControl = new LoaderDownloadPartitionControl();
    HeadTsPacket tsHead = new HeadTsPacket();
    tsHead.setSynByte((byte)71);
    tsHead.setTransportErrorIndicator1((byte)0);
    tsHead.setPayloadUnitStartIndicator1((byte)1);
    tsHead.setTransportPriority1((byte)0);
    tsHead.setTransportScramblingControl2((byte)0);
    tsHead.setAdaptationFieldControl2((byte)1);
    Arrays.fill(tsBuffer, (byte)-1);
    RandomFileOutputStream out = newOutputStream(strFilePathName);
    if (out == null)
      return Status.CANCEL_STATUS; 
    monitor.worked(5);
    int dataPackage = info.getDataPackage();
    try {
      monitor.setTaskName("Compute all of part file crc");
      setPartFiles(fillFileDataStruct(files));
      if (monitor.isCanceled())
        return Status.CANCEL_STATUS; 
      monitor.worked(10);
      setPartitionNum(getPartFiles().size());
      monitor.setTaskName("Package Part file..");
      for (int partIndex = 0; partIndex < getPartitionNum(); partIndex++) {
        PartFile partFile = getPartFiles().get(partIndex);
        long[] values = { partFile.getSectionNum(), partFile.getLastDiagramDataLength(), partFile.getDatagramNum() };
        tsHead.setPid13(getG_struFrontend().getU16TsPID());
        monitor.worked(20);
        long sectionCount = values[0];
        SubProgressMonitor subProgressMonitor = null;
      } 
    } finally {
      monitor.worked(20);
      try {
        out.close();
        if (monitor.isCanceled())
          FileUtil.deleteFile(strFilePathName); 
      } catch (Exception e) {
        throw new LoaderException(Messages.TsPackageBuilder_CreateError);
      } 
    } 
    return Status.OK_STATUS;
  }
  
  private static void loadingDiagramData(LoaderDatagramData partDatagram, PartFile partFile, int partIndex, int sectionIndex, long[] values) {
    int u32SectionHeadLen = 9;
    int u32DataTopSize = 7 + SEC_RESERVED_DATA_LEN();
    long dataLength = 0L;
    int u32CRClen = 4;
    long sectionNum = values[0];
    long lastSectionLength = values[1];
    long dataGramNum = values[2];
    RandomAccessFile file = null;
    try {
      file = new RandomAccessFile(new File(partFile.getFileName()), "r");
      partDatagram.newLoaderDatagram(1);
      partDatagram.setU32DatagramFragNum((int)sectionNum);
      short u8TableId = (short)getG_struFrontend().getU8TableID();
      short u8LastSectionNum = 0;
      if ((sectionIndex / 8 + 1) < dataGramNum) {
        u8LastSectionNum = 8;
      } else {
        u8LastSectionNum = (short)(int)((sectionNum % 8L == 0L) ? 8L : (sectionNum % 8L));
      } 
      fillDownloadDatagramSecHead(partDatagram
          .getStruLoaderDatagramFrag()[0].getStSecHead(), u8TableId, sectionIndex / 8 + 1, (short)partIndex, u8LastSectionNum);
      if (sectionNum - 1L == sectionIndex) {
        dataLength = lastSectionLength;
      } else {
        dataLength = 992L;
      } 
      int u32TotleLen = (int)((u32SectionHeadLen + u32DataTopSize) + dataLength + (2 * u32CRClen));
      partDatagram.getStruLoaderDatagramFrag()[0].setSecBufAddr(new byte[u32TotleLen]);
      memset(partDatagram.getStruLoaderDatagramFrag()[0].getSecBufAddr(), 0, u32TotleLen);
      partDatagram.getStruLoaderDatagramFrag()[0].setSecLen(u32TotleLen);
      partDatagram.getStruLoaderDatagramFrag()[0].getStSecHead()
        .setSectionLength12((short)(u32TotleLen - 4));
      fillSecHead(partDatagram.getStruLoaderDatagramFrag()[0].getStSecHead(), partDatagram
          .getStruLoaderDatagramFrag()[0].getSecBufAddr());
      fillDownloadDatagramData(partDatagram
          .getStruLoaderDatagramFrag()[0].getSecBufAddr(), u32SectionHeadLen, file, sectionIndex * 992L, (short)(sectionIndex % 8 + 1), (int)dataLength, tempSectionData);
      int crc = Crc32.compute(partDatagram
          .getStruLoaderDatagramFrag()[0].getSecBufAddr(), 1, u32TotleLen - 1 - u32CRClen);
      alterU32ToU8(partDatagram.getStruLoaderDatagramFrag()[0].getSecBufAddr(), u32TotleLen - u32CRClen, crc);
    } catch (FileNotFoundException fileNotFoundException) {
      try {
        if (file != null)
          file.close(); 
      } catch (IOException iOException) {}
    } finally {
      try {
        if (file != null)
          file.close(); 
      } catch (IOException iOException) {}
    } 
  }
  
  private static RandomFileOutputStream newOutputStream(String strFilePathName) throws FileNotFoundException, LoaderException {
    FileUtil.deleteFile(strFilePathName);
    if (!FileUtil.canWriteFile(strFilePathName, Messages.TsPackageBuilder_CreateError))
      return null; 
    RandomFileOutputStream fp = null;
    try {
      fp = new RandomFileOutputStream(strFilePathName);
    } catch (Exception e) {
      throw new LoaderException(Messages.TsPackageBuilder_CreateError);
    } 
    return fp;
  }
  
  public static void writeByte(byte[] src, int srcPos, byte[] dest, int destPos, int length) {
    System.arraycopy(src, srcPos, dest, destPos, length);
  }
  
  private static void construct_TsHead(byte[] out, HeadTsPacket pstrHeadTsPak, int destPos) throws LoaderException {
    byte[] headBuf = new byte[4];
    headBuf[0] = pstrHeadTsPak.getSynByte();
    headBuf[1] = 


      
      (byte)(0x0 | pstrHeadTsPak.getTransportErrorIndicator1() << 7 | pstrHeadTsPak.getPayloadUnitStartIndicator1() << 6 | pstrHeadTsPak.getTransportPriority1() << 5 | pstrHeadTsPak.getPid13() >>> 8 & 0x1F);
    headBuf[2] = (byte)(pstrHeadTsPak.getPid13() & 0xFF);
    headBuf[3] = 

      
      (byte)(0x0 | pstrHeadTsPak.getTransportScramblingControl2() << 6 | pstrHeadTsPak.getAdaptationFieldControl2() << 4 | pstrHeadTsPak.getContinuityCounter4());
    writeByte(headBuf, 0, out, destPos, headBuf.length);
  }
  
  private static int[] fillTsPackage(byte[] fp, HeadTsPacket strHeadTsPak, byte[] pTmp, int pTempOffset, int lenDownloadCtrl, int count, byte[] tsBuf) throws LoaderException, IOException {
    int oldLen = 0;
    strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
    if (count > 15)
      count = 0; 
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    construct_TsHead(fp, strHeadTsPak, 0);
    pTempOffset += 4;
    if (lenDownloadCtrl > 184) {
      while (lenDownloadCtrl > 184) {
        writeByte(pTmp, oldLen, fp, pTempOffset, 184);
        lenDownloadCtrl -= 184;
        oldLen += 184;
        strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
        if (count > 15)
          count = 0; 
        strHeadTsPak.setPayloadUnitStartIndicator1((byte)0);
        pTempOffset += 184;
        construct_TsHead(fp, strHeadTsPak, pTempOffset);
        pTempOffset += 4;
      } 
      writeByte(pTmp, oldLen, fp, pTempOffset, lenDownloadCtrl);
      pTempOffset += lenDownloadCtrl;
      writeByte(tsBuf, 0, fp, pTempOffset, 184 - lenDownloadCtrl);
      pTempOffset += 184 - lenDownloadCtrl;
    } else {
      writeByte(pTmp, oldLen, fp, pTempOffset, lenDownloadCtrl);
      pTempOffset += lenDownloadCtrl;
      writeByte(tsBuf, 0, fp, pTempOffset, 184 - lenDownloadCtrl);
      pTempOffset += 184 - lenDownloadCtrl;
    } 
    int[] temp = new int[2];
    temp[0] = count;
    temp[1] = pTempOffset;
    return temp;
  }
  
  private static int fillTsPackage(RandomFileOutputStream fp, HeadTsPacket strHeadTsPak, byte[] pTmp, int pTempOffset, int lenDownloadCtrl, int count, byte[] tsBuf) throws LoaderException, IOException {
    strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
    if (count > 15)
      count = 0; 
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    try {
      fillTsHead((OutputStream)fp, strHeadTsPak);
      if (lenDownloadCtrl > 184) {
        while (lenDownloadCtrl > 184) {
          fp.write(pTmp, pTempOffset, 184);
          lenDownloadCtrl -= 184;
          strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
          if (count > 15)
            count = 0; 
          strHeadTsPak.setPayloadUnitStartIndicator1((byte)0);
          fillTsHead((OutputStream)fp, strHeadTsPak);
          pTempOffset += 184;
        } 
        fp.write(pTmp, pTempOffset, lenDownloadCtrl);
        fp.write(tsBuf, 0, 184 - lenDownloadCtrl);
      } else {
        fp.write(pTmp, pTempOffset, lenDownloadCtrl);
        fp.write(tsBuf, 0, 184 - lenDownloadCtrl);
      } 
    } catch (Exception e) {
      closeStream(fp);
      throw new LoaderException(Messages.TsPackageBuilder_CreateError);
    } 
    fflush(fp);
    return count;
  }
  
  private static void fflush(RandomFileOutputStream fp) throws LoaderException {
    try {
      fp.flush();
    } catch (IOException e) {
      throw new LoaderException(Messages.TsPackageBuilder_CreateError);
    } 
  }
  
  private static void closeStream(RandomFileOutputStream fp) {
    try {
      fp.close();
    } catch (IOException iOException) {}
  }
  
  private static void fillDownloadControlDownInfo(LoaderDownloadInfo pDownloadInfo) {
    int u32CrcVal = 0;
    short reserverd_tag = 1;
    int reserverd_data_length = 8;
    int u32LoaderDownloadInfoLen = 29;
    pDownloadInfo.setDownloadInfoTag((byte)-22);
    pDownloadInfo.setDownloadTableId(getG_struFrontend().getU8TableID());
    pDownloadInfo
      .setKeyControl((byte)31);
    pDownloadInfo.setStbManufacturerId((short)(int)getG_FactoryIdFlag());
    pDownloadInfo.setHardwareVer((int)getG_HardwareVersion());
    pDownloadInfo.setSoftwareVer((int)getG_softwareVersion());
    pDownloadInfo.setSerialNumberStart((int)getG_start_sn());
    pDownloadInfo.setSerialNumberEnd((int)getG_end_sn());
    pDownloadInfo.setDownloadDate((int)g_download_date);
    if (1 == (pDownloadInfo.getKeyControl() & 0x1)) {
      pDownloadInfo.setWebBrowserVer((int)g_appVersion);
      u32LoaderDownloadInfoLen += 4;
    } 
    if (2 == (pDownloadInfo.getKeyControl() & 0x2)) {
      pDownloadInfo.setKernelVer(1);
      u32LoaderDownloadInfoLen += 4;
    } 
    if (4 == (pDownloadInfo.getKeyControl() & 0x4)) {
      pDownloadInfo.setCaVer(1);
      u32LoaderDownloadInfoLen += 4;
    } 
    if (8 == (pDownloadInfo.getKeyControl() & 0x8)) {
      pDownloadInfo.setBootLoaderVer(1);
      u32LoaderDownloadInfoLen += 4;
    } 
    if (16 == (pDownloadInfo.getKeyControl() & 0x10)) {
      pDownloadInfo.setLoaderVer(1);
      u32LoaderDownloadInfoLen += 4;
    } 
    byte[] au8ProductHardName = new byte[40];
    Arrays.fill(au8ProductHardName, (byte)0);
    memcpy(au8ProductHardName, 0, "vendor001", 40L);
    pDownloadInfo.setHardwareStringLen((byte)strlen(au8ProductHardName));
    pDownloadInfo.setHardwareStringDescriptor(au8ProductHardName);
    if (enDownloadMode == DownloadMode.MODE_FLASH) {
      LoaderDownloadPartitionModeFlash struDLPartitionModeFlash = new LoaderDownloadPartitionModeFlash();
      struDLPartitionModeFlash
        .setDownloadPartInfoTag((byte)-21);
      struDLPartitionModeFlash.setPartitionCount((byte)getPartitionNum());
      struDLPartitionModeFlash.setReserved((byte)-1);
      int part_descritption_length = 0;
      if (is64Bit()) {
        part_descritption_length = getPartitionNum() * 18;
      } else {
        part_descritption_length = getPartitionNum() * 14;
      } 
      struDLPartitionModeFlash.setPartDescritptionLength((short)part_descritption_length);
      for (int i = 0; i < getPartitionNum(); i++) {
        struDLPartitionModeFlash.getPartDescritption()[i] = new LoaderPartDesc();
        struDLPartitionModeFlash.getPartDescritption()[i]
          .setDownloadMode((byte)DownloadMode.MODE_FLASH.ordinal());
        if (is64Bit()) {
          struDLPartitionModeFlash.getPartDescritption()[i]
            .setDownloadModeDataLen((byte)16);
        } else {
          struDLPartitionModeFlash.getPartDescritption()[i]
            .setDownloadModeDataLen((byte)12);
        } 
        PartFile partFile = getPartFiles().get(i);
        struDLPartitionModeFlash.getPartDescritption()[i].getDownloadModeFlash()
          .setDownloadAddr(partFile.getBurnAddr());
        struDLPartitionModeFlash.getPartDescritption()[i].getDownloadModeFlash()
          .setDownloadSize(partFile.getFileSize());
        struDLPartitionModeFlash.getPartDescritption()[i].getDownloadModeFlash()
          .setDownloadCrc32(partFile.getCrcValue());
        g_u32DataTotleLen += partFile.getFileSize();
      } 
      struDLPartitionModeFlash
        .setDownloadDataTotalSize(g_u32DataTotleLen);
      byte[] au8UpgrdDesInfo = new byte[40];
      memset(au8UpgrdDesInfo, 0, 40);
      memcpy(au8UpgrdDesInfo, 0, "product update 2007!", 40L);
      struDLPartitionModeFlash
        .setDownloadDescriptionLength((byte)strlen(au8UpgrdDesInfo));
      struDLPartitionModeFlash.downloadDescriptionString = au8UpgrdDesInfo;
      if (is64Bit()) {
        struDLPartitionModeFlash.setDownloadPartInfoLen(

            
            (byte)(8 + part_descritption_length + 1 + struDLPartitionModeFlash.getDownloadDescriptionLength() + 11));
      } else if (isIs32Bit()) {
        struDLPartitionModeFlash
          .setDownloadPartInfoLen(


            
            (byte)(8 + part_descritption_length + 1 + struDLPartitionModeFlash.getDownloadDescriptionLength() + 11));
      } else {
        struDLPartitionModeFlash
          .setDownloadPartInfoLen(



            
            (byte)(12 + part_descritption_length + 1 + struDLPartitionModeFlash.getDownloadDescriptionLength() + 11));
      } 
      byte[] au8UpgrdPartInfo = null;
      if (is64Bit()) {
        au8UpgrdPartInfo = new byte[4674];
        memset(au8UpgrdPartInfo, 0, 4674);
      } else if (isIs32Bit()) {
        au8UpgrdPartInfo = new byte[3650];
        memset(au8UpgrdPartInfo, 0, 3650);
      } else {
        au8UpgrdPartInfo = new byte[3654];
        memset(au8UpgrdPartInfo, 0, 3654);
      } 
      byte[] pu8Temp = au8UpgrdPartInfo;
      int offset = 0;
      pu8Temp[offset++] = struDLPartitionModeFlash
        .getDownloadPartInfoTag();
      pu8Temp[offset++] = struDLPartitionModeFlash
        .getDownloadPartInfoLen();
      if (is64Bit()) {
        offset = alterU32ToU8(pu8Temp, offset, 
            
            (int)struDLPartitionModeFlash.getDownloadDataTotalSize());
      } else if (isIs32Bit()) {
        offset = alterU32ToU8(pu8Temp, offset, 
            
            (int)struDLPartitionModeFlash.getDownloadDataTotalSize());
      } else {
        offset = alterU64ToU8(pu8Temp, offset, struDLPartitionModeFlash
            .getDownloadDataTotalSize());
      } 
      pu8Temp[offset++] = struDLPartitionModeFlash
        .getPartitionCount();
      pu8Temp[offset++] = struDLPartitionModeFlash.getReserved();
      offset = alterU16ToU8(pu8Temp, offset, struDLPartitionModeFlash
          
          .getPartDescritptionLength());
      for (int j = 0; j < getPartitionNum(); j++) {
        pu8Temp[offset++] = struDLPartitionModeFlash.getPartDescritption()[j]
          .getDownloadMode();
        pu8Temp[offset++] = struDLPartitionModeFlash.getPartDescritption()[j]
          .getDownloadModeDataLen();
        if (is64Bit()) {
          offset = alterU64ToU8(pu8Temp, offset, struDLPartitionModeFlash

              
              .getPartDescritption()[j].getDownloadModeFlash()
              .getDownloadAddr());
        } else {
          offset = alterU32ToU8(pu8Temp, offset, 


              
              (int)struDLPartitionModeFlash.getPartDescritption()[j].getDownloadModeFlash().getDownloadAddr());
        } 
        offset = alterU32ToU8(pu8Temp, offset, 

            
            (int)struDLPartitionModeFlash.getPartDescritption()[j].getDownloadModeFlash().getDownloadSize());
        offset = alterU32ToU8(pu8Temp, offset, struDLPartitionModeFlash

            
            .getPartDescritption()[j].getDownloadModeFlash()
            .getDownloadCrc32());
      } 
      pu8Temp[offset++] = struDLPartitionModeFlash.getDownloadDescriptionLength();
      memcpy(pu8Temp, offset, struDLPartitionModeFlash
          .getDownloadDescriptionString(), 
          (short)struDLPartitionModeFlash.getDownloadDescriptionLength());
      offset += struDLPartitionModeFlash.getDownloadDescriptionLength();
      if (TOTAL_DATA_CRC_ENBALE) {
        pu8Temp[offset++] = (byte)reserverd_tag;
        offset = alterU16ToU8(pu8Temp, offset, (short)reserverd_data_length);
        offset = alterU32ToU8(pu8Temp, offset, g_u32DataCrc);
        offset = alterU32ToU8(pu8Temp, offset, (int)g_u32DataMagicNum);
      } 
      u32CrcVal = Crc32.compute(au8UpgrdPartInfo, 2, struDLPartitionModeFlash
          .getDownloadPartInfoLen());
      offset = alterU32ToU8(pu8Temp, offset, u32CrcVal);
      pDownloadInfo.setDownloadPartInfo(au8UpgrdPartInfo);
      pDownloadInfo.setDownloadInfoLen(
          (byte)(u32LoaderDownloadInfoLen - 2 + pDownloadInfo.getHardwareStringLen()));
      g_u32DataTotleLen = 0L;
    } 
  }
  
  private static void memcpy(byte[] pu8Temp, int offset, byte[] downloadDescriptionString, short len) {
    System.arraycopy(downloadDescriptionString, 0, pu8Temp, offset, len);
  }
  
  private static void memset(byte[] buf, int value, int len) {
    assert buf.length == len;
    Arrays.fill(buf, (byte)value);
  }
  
  private static short strlen(byte[] au8ProductHardName) {
    for (int i = 0; i < au8ProductHardName.length; i++) {
      if (au8ProductHardName[i] == 0)
        return (short)i; 
    } 
    return (short)au8ProductHardName.length;
  }
  
  private static void fillTsHead(OutputStream out, HeadTsPacket pstrHeadTsPak) throws LoaderException {
    byte[] headBuf = new byte[4];
    headBuf[0] = pstrHeadTsPak.getSynByte();
    headBuf[1] = 


      
      (byte)(0x0 | pstrHeadTsPak.getTransportErrorIndicator1() << 7 | pstrHeadTsPak.getPayloadUnitStartIndicator1() << 6 | pstrHeadTsPak.getTransportPriority1() << 5 | pstrHeadTsPak.getPid13() >>> 8 & 0x1F);
    headBuf[2] = (byte)(pstrHeadTsPak.getPid13() & 0xFF);
    headBuf[3] = 

      
      (byte)(0x0 | pstrHeadTsPak.getTransportScramblingControl2() << 6 | pstrHeadTsPak.getAdaptationFieldControl2() << 4 | pstrHeadTsPak.getContinuityCounter4());
    try {
      out.write(headBuf);
      out.flush();
    } catch (IOException e) {
      throw new LoaderException(Messages.TsPackageBuilder_FillError);
    } 
  }
  
  private static void fillSecHead(SectionHead pSecHead, byte[] secBuf) {
    secBuf[0] = 0;
    secBuf[1] = pSecHead.getTableId();
    secBuf[2] = 
      (byte)(0x0 | pSecHead.getSectionSyntaxIndicator1() << 7 | 0x70 | (pSecHead.getSectionLength12() & 0xF00) >> 8);
    secBuf[3] = (byte)(pSecHead.getSectionLength12() & 0xFF);
    secBuf[4] = (byte)((pSecHead.getTableIdExtension() & 0xFF00) >> 8);
    secBuf[5] = (byte)(pSecHead.getTableIdExtension() & 0xFF);
    secBuf[6] = pSecHead.getVersionNumber();
    secBuf[7] = pSecHead.getSectionNumber();
    secBuf[8] = pSecHead.getLastSectionNumber();
  }
  
  private static int alterU64ToU8(byte[] pu8Data, int offset, long u64Data) {
    pu8Data[offset] = (byte)(int)(u64Data >> 56L & 0xFFL);
    pu8Data[offset + 1] = (byte)(int)(u64Data >> 48L & 0xFFL);
    pu8Data[offset + 2] = (byte)(int)(u64Data >> 40L & 0xFFL);
    pu8Data[offset + 3] = (byte)(int)(u64Data >> 32L & 0xFFL);
    pu8Data[offset + 4] = (byte)(int)(u64Data >> 24L & 0xFFL);
    pu8Data[offset + 5] = (byte)(int)(u64Data >> 16L & 0xFFL);
    pu8Data[offset + 6] = (byte)(int)(u64Data >> 8L & 0xFFL);
    pu8Data[offset + 7] = (byte)(int)(u64Data & 0xFFL);
    offset += 8;
    return offset;
  }
  
  private static int alterU32LowToU8(byte[] pu8Data, int offset, int u32Data) {
    pu8Data[offset] = 0;
    pu8Data[offset + 1] = 0;
    pu8Data[offset + 2] = 0;
    pu8Data[offset + 3] = (byte)(u32Data & 0xFF);
    return offset + 4;
  }
  
  private static int alterU32ToU8(byte[] pu8Data, int offset, int u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF000000) >>> 24);
    pu8Data[offset + 1] = (byte)((u32Data & 0xFF0000) >>> 16);
    pu8Data[offset + 2] = (byte)((u32Data & 0xFF00) >>> 8);
    pu8Data[offset + 3] = (byte)(u32Data & 0xFF);
    return offset + 4;
  }
  
  private static int alterU16ToU8(byte[] pu8Data, int offset, short u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF00) >>> 8);
    pu8Data[offset + 1] = (byte)(u32Data & 0xFF);
    return offset + 2;
  }
  
  private static void fillDownloadDatagramData(byte[] pu8DesData, int offset, RandomAccessFile fileConetent, long srcOffset, short u8DatagramCurSecNum, int u32DataLen, byte[] temp) {
    int destOffset = offset;
    destOffset = alterU32ToU8(pu8DesData, destOffset, (int)g_u32DataMagicNum);
    destOffset = alterU16ToU8(pu8DesData, destOffset, (short)g_u16SecResvDataLen);
    pu8DesData[destOffset++] = (byte)(0x80 | u8DatagramCurSecNum);
    destOffset = alterU16ToU8(pu8DesData, destOffset, (short)u32DataLen);
    try {
      fileConetent.seek(srcOffset);
      int read = fileConetent.read(temp, 0, u32DataLen);
      System.arraycopy(temp, 0, pu8DesData, destOffset, read);
      destOffset += read;
    } catch (IOException iOException) {}
    int u32Crc = Crc32.compute(pu8DesData, offset + 3 + 4 + 
        SEC_RESERVED_DATA_LEN(), u32DataLen);
    alterU32ToU8(pu8DesData, destOffset, u32Crc);
  }
  
  public static void fillDownloadDatagramData(byte[] pu8DesData, int offset, byte[] fileConetent, int srcOffset, short u8DatagramCurSecNum, int u32DataLen) {
    int destOffset = offset;
    destOffset = alterU32ToU8(pu8DesData, destOffset, (int)g_u32DataMagicNum);
    destOffset = alterU16ToU8(pu8DesData, destOffset, (short)g_u16SecResvDataLen);
    pu8DesData[destOffset++] = (byte)(0x80 | u8DatagramCurSecNum);
    destOffset = alterU16ToU8(pu8DesData, destOffset, (short)u32DataLen);
    System.arraycopy(fileConetent, srcOffset, pu8DesData, destOffset, u32DataLen);
    destOffset += u32DataLen;
    int u32Crc = Crc32.compute(pu8DesData, offset + 3 + 4 + 
        SEC_RESERVED_DATA_LEN(), u32DataLen);
    alterU32ToU8(pu8DesData, destOffset, u32Crc);
  }
  
  private static void fillDownloadDatagramSecHead(SectionHead pSectionHead, short u8TableId, int u16TableExId, short u8SectionNum, short last_section_number) {
    pSectionHead.setTableId((byte)u8TableId);
    pSectionHead.setSectionSyntaxIndicator1((byte)1);
    pSectionHead.setTableIdExtension((short)u16TableExId);
    pSectionHead.setVersionNumber((byte)0);
    pSectionHead.setSectionNumber((byte)(u8SectionNum + 1));
    pSectionHead.setLastSectionNumber((byte)last_section_number);
  }
  
  private static void fillDownloadPartitionSecHead(SectionHead sectionHead, short tableId, short partitionIndex) {
    sectionHead.setTableId((byte)tableId);
    sectionHead.setSectionSyntaxIndicator1((byte)1);
    sectionHead.setTableIdExtension((short)0);
    sectionHead.setVersionNumber((byte)0);
    sectionHead.setSectionNumber((byte)(partitionIndex + 1));
    sectionHead.setLastSectionNumber((byte)1);
  }
  
  private static void fillDownloadControlSecHead(SectionHead pSectionHead) {
    pSectionHead.setTableId((byte)-2);
    pSectionHead.setSectionSyntaxIndicator1((byte)1);
    pSectionHead.setTableIdExtension((short)0);
    pSectionHead.setVersionNumber((byte)0);
    pSectionHead.setSectionNumber((byte)0);
    pSectionHead.setLastSectionNumber((byte)1);
  }
  
  private static void fillCableDeliveryDescriptor(DeliverySysDescriptor pDeliDeptor) {
    pDeliDeptor.setDesTag((byte)68);
    pDeliDeptor.setFre(307000);
    pDeliDeptor.setFecInner((short)15);
    pDeliDeptor.setFecOuter((short)2);
    pDeliDeptor.setModulate((short)2);
    pDeliDeptor.setSymrate(6875000);
    pDeliDeptor.setDesLen((byte)11);
  }
  
  private static void fillCodeDownloadDescriptor(CodeDownloadDescriptor pDLDesptor) {
    pDLDesptor.setDescriptorTag((byte)-95);
    pDLDesptor.setDownloadPid13((short)22);
    pDLDesptor.setDownloadType3((byte)0);
    pDLDesptor.setKeyControl((byte)63);
    pDLDesptor.setHardwareVer(2);
    pDLDesptor.setSoftwareVer(0);
    pDLDesptor.setStbManufacturerId((short)1);
    pDLDesptor.setWebbrowserVer(4);
    pDLDesptor.setKernelVer(5);
    pDLDesptor.setCaVer(6);
    pDLDesptor.setBootLoaderVer(7);
    pDLDesptor.setLoaderVer(8);
    pDLDesptor.setUpdateDate(4369);
    pDLDesptor.setLogoVer(9);
    pDLDesptor.setSerialNumberStart(1);
    pDLDesptor.setSerialNumberEnd(5);
    pDLDesptor.setString("vendor001");
    pDLDesptor.setStringLen((byte)pDLDesptor.getString().length());
    pDLDesptor.setPrivateDataLen((byte)(pDLDesptor.getStringLen() + 1 + 44 + 1));
    pDLDesptor.setDescriptorLen((byte)(pDLDesptor.getPrivateDataLen() + 1 + 2 + 13 + 2));
  }
  
  private static void fillDownloadPartitionControlInfoFlash(LoaderDownloadPartitionControlInfoFlash pstruDownloadPartitionControlInfoFlash, int uPartNum, List<PartFile> headers) {
    PartFile g_struPartFile = headers.get(uPartNum);
    pstruDownloadPartitionControlInfoFlash
      .setPartHeadTag((byte)-20);
    if (is64Bit()) {
      pstruDownloadPartitionControlInfoFlash
        .setPartNewVer(g_struPartFile.getPartitionVersion());
      String name = g_struPartFile.getPartitionName();
      if (name == null || name.isEmpty()) {
        pstruDownloadPartitionControlInfoFlash
          .setDownloadstringLength((short)0);
        pstruDownloadPartitionControlInfoFlash
          .setDownloadstring_char(null);
        int partitionLength = 4;
        pstruDownloadPartitionControlInfoFlash
          .setPartHeadDataLen((byte)(53 + partitionLength));
      } else {
        pstruDownloadPartitionControlInfoFlash
          .setDownloadstringLength((short)name.length());
        pstruDownloadPartitionControlInfoFlash
          .setDownloadstring_char(g_struPartFile
            .getPartitionName());
        int partitionLength = 4 + name.length();
        pstruDownloadPartitionControlInfoFlash
          .setPartHeadDataLen((byte)(53 + partitionLength));
      } 
      pstruDownloadPartitionControlInfoFlash
        .setPartitionVerifyTag(g_struPartFile.getPartitionVerifyTag());
    } else {
      pstruDownloadPartitionControlInfoFlash.setPartNewVer(1);
      if (isIs32Bit()) {
        pstruDownloadPartitionControlInfoFlash
          .setPartHeadDataLen((byte)45);
      } else {
        pstruDownloadPartitionControlInfoFlash
          .setPartHeadDataLen((byte)53);
      } 
    } 
    pstruDownloadPartitionControlInfoFlash
      .setDownloadType((byte)DownloadMode.MODE_FLASH.ordinal());
    pstruDownloadPartitionControlInfoFlash.setReserved((byte)-1);
    pstruDownloadPartitionControlInfoFlash
      .setPartDatagramNumber((short)g_struPartFile.getDatagramNum());
    pstruDownloadPartitionControlInfoFlash
      .setPartTotalSize(g_struPartFile.getFileSize());
    pstruDownloadPartitionControlInfoFlash.setPartOriSize(400);
    pstruDownloadPartitionControlInfoFlash.setPartOldVerStart(0);
    pstruDownloadPartitionControlInfoFlash.setPartOldVerEnd(0);
    pstruDownloadPartitionControlInfoFlash.setStartAddr(g_struPartFile
        .getBurnAddr());
    pstruDownloadPartitionControlInfoFlash
      .setuFlashType(g_struPartFile.getuFlashType().ordinal());
    pstruDownloadPartitionControlInfoFlash
      .setlFlashIndex(g_struPartFile.getlFlashIndex());
    pstruDownloadPartitionControlInfoFlash
      .setuPartitionEndAddr(g_struPartFile.getuPartitionEndAddr());
  }
  
  private static void fillNitSecContext(NitSection pNitSec) {
    DeliverySysDescriptor deliveryDescriptor = new DeliverySysDescriptor();
    NetworkNameDescriptor networkNameDescriptor = new NetworkNameDescriptor();
    CodeDownloadDescriptor codeDownloadDescriptor = new CodeDownloadDescriptor();
    int u32CrcVal = 0;
    networkNameDescriptor.setDescriptorTag((byte)64);
    try {
      networkNameDescriptor.setpString("Topway Cable TV"
          .getBytes(WorkbenchEncoding.getWorkbenchDefaultEncoding()));
    } catch (UnsupportedEncodingException e) {
      return;
    } 
    networkNameDescriptor
      .setDescriptorLen((byte)(networkNameDescriptor.getpString()).length);
    fillCableDeliveryDescriptor(deliveryDescriptor);
    fillCodeDownloadDescriptor(codeDownloadDescriptor);
    pNitSec.getStSecHead().setTableId((byte)64);
    pNitSec.getStSecHead().setSectionSyntaxIndicator1((byte)1);
    pNitSec.getStSecHead().setTableIdExtension((short)0);
    pNitSec.getStSecHead().setVersionNumber((byte)(int)g_softwareVersion);
    pNitSec.getStSecHead().setSectionNumber((byte)0);
    pNitSec.getStSecHead().setLastSectionNumber((byte)0);
    codeDownloadDescriptor.setDeliverySysDescriptor(deliveryDescriptor);
    pNitSec.setNetworkDescriptorLen(

        
        (short)(2 + networkNameDescriptor.getDescriptorLen() + 2 + codeDownloadDescriptor.getDescriptorLen()));
    pNitSec.setTransportStreamsLen((byte)0);
    int len = 2 + pNitSec.getNetworkDescriptorLen() + 2 + pNitSec.getTransportStreamsLen() + 4 + 5;
    pNitSec.getStSecHead().setSectionLength12((short)len);
    int totalLen = len + 3 + 1;
    pNitSec.secBufAddr = new byte[totalLen];
    Arrays.fill(pNitSec.secBufAddr, (byte)0);
    byte[] pTmp = pNitSec.secBufAddr;
    int offset = 9;
    pTmp[offset++] = 
      (byte)(240 + ((pNitSec.getNetworkDescriptorLen() & 0xF00) >>> 8));
    pTmp[offset++] = (byte)(pNitSec.getNetworkDescriptorLen() & 0xFF);
    pTmp[offset++] = networkNameDescriptor.getDescriptorTag();
    pTmp[offset++] = networkNameDescriptor.getDescriptorLen();
    System.arraycopy(networkNameDescriptor.getpString(), 0, pTmp, offset, networkNameDescriptor
        .getDescriptorLen());
    offset += networkNameDescriptor.getDescriptorLen();
    pTmp[offset++] = codeDownloadDescriptor.getDescriptorTag();
    pTmp[offset++] = codeDownloadDescriptor.getDescriptorLen();
    pTmp[offset++] = 
      (byte)((codeDownloadDescriptor.getStbManufacturerId() & 0xFF00) >>> 8);
    pTmp[offset++] = (byte)(codeDownloadDescriptor.getStbManufacturerId() & 0xFF);
    pTmp[offset++] = deliveryDescriptor.getDesTag();
    pTmp[offset++] = deliveryDescriptor.getDesLen();
    offset = putFourByte(deliveryDescriptor.getFre(), pTmp, offset);
    pTmp[offset++] = -1;
    pTmp[offset++] = 
      (byte)(0xF0 | deliveryDescriptor.getFecOuter() & 0xF);
    pTmp[offset++] = (byte)deliveryDescriptor.getModulate();
    pTmp[offset++] = (byte)((deliveryDescriptor.getSymrate() & 0xFF00000) >>> 20);
    pTmp[offset++] = (byte)((deliveryDescriptor.getSymrate() & 0xFF0) >>> 4);
    pTmp[offset++] = 
      (byte)((deliveryDescriptor.getSymrate() & 0xF) << 4 | deliveryDescriptor.getFecInner() & 0xF);
    pTmp[offset++] = (byte)((codeDownloadDescriptor.getDownloadPid13() & 0x1FE0) >>> 5);
    pTmp[offset++] = 
      (byte)((codeDownloadDescriptor.getDownloadPid13() & 0x1F) << 3 | codeDownloadDescriptor.getDownloadPid13() & 0x7);
    pTmp[offset++] = codeDownloadDescriptor.getPrivateDataLen();
    pTmp[offset++] = codeDownloadDescriptor.getKeyControl();
    offset = putFourByte(codeDownloadDescriptor.getHardwareVer(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor.getSoftwareVer(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor.getWebbrowserVer(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor.getKernelVer(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor.getCaVer(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor.getBootLoaderVer(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor.getLoaderVer(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor.getLogoVer(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor
        .getSerialNumberStart(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor
        .getSerialNumberEnd(), pTmp, offset);
    offset = putFourByte(codeDownloadDescriptor.getUpdateDate(), pTmp, offset);
    pTmp[offset++] = codeDownloadDescriptor.getStringLen();
    memcpy(pTmp, offset, codeDownloadDescriptor.getString(), codeDownloadDescriptor
        .getStringLen());
    offset += codeDownloadDescriptor.getStringLen();
    fillSecHead(pNitSec.getStSecHead(), pTmp);
    u32CrcVal = Crc32.compute(pTmp, 1, totalLen - 4 - 1);
    alterU32ToU8(pTmp, totalLen - 4, u32CrcVal);
    pNitSec.setSecLen(totalLen);
  }
  
  private static void fillDownloadPartitionSecContext(LoaderDownloadPartitionControl partitionControl, int partIndex) {
    int tableId = getG_struFrontend().getU8TableID();
    LoaderDownloadPartitionControlInfoFlash struDownloadPartitionControlInfoFlash = new LoaderDownloadPartitionControlInfoFlash();
    int sectionHeadLength = 9;
    int u32CRClen = 4;
    fillDownloadPartitionSecHead(partitionControl.getStSecHead(), (short)tableId, (short)partIndex);
    fillDownloadPartitionControlInfoFlash(struDownloadPartitionControlInfoFlash, partIndex, 
        
        getPartFiles());
    int partitionControlInfoFlashLength = struDownloadPartitionControlInfoFlash.getPartHeadDataLen() + 2;
    int totalLength = sectionHeadLength + partitionControlInfoFlashLength + u32CRClen;
    partitionControl.setSecBufAddr(new byte[totalLength]);
    Arrays.fill(partitionControl.getSecBufAddr(), (byte)0);
    partitionControl.setSecLen(totalLength);
    partitionControl.getStSecHead().setSectionLength12((short)(totalLength - 4));
    fillSecHead(partitionControl.getStSecHead(), partitionControl.getSecBufAddr());
    byte[] pu8Temp = partitionControl.getSecBufAddr();
    int offset = sectionHeadLength;
    pu8Temp[offset++] = struDownloadPartitionControlInfoFlash.getPartHeadTag();
    pu8Temp[offset++] = struDownloadPartitionControlInfoFlash.getPartHeadDataLen();
    pu8Temp[offset++] = struDownloadPartitionControlInfoFlash.getDownloadType();
    pu8Temp[offset++] = struDownloadPartitionControlInfoFlash.getReserved();
    offset = alterU16ToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash


        
        .getPartDatagramNumber());
    offset = alterU32ToU8(pu8Temp, offset, 
        (int)struDownloadPartitionControlInfoFlash.getPartTotalSize());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash
        .getPartOriSize());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash
        
        .getPartOldVerStart());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash
        .getPartOldVerEnd());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash
        .getPartNewVer());
    if (isIs32Bit()) {
      offset = alterU32ToU8(pu8Temp, offset, 
          (int)struDownloadPartitionControlInfoFlash.getStartAddr());
    } else {
      offset = alterU64ToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash
          .getStartAddr());
    } 
    if (is64Bit()) {
      int length = struDownloadPartitionControlInfoFlash.getDownloadstringLength();
      if (length == 0) {
        offset = alterU16ToU8(pu8Temp, offset, (short)0);
      } else {
        offset = alterU16ToU8(pu8Temp, offset, (short)length);
        String name = struDownloadPartitionControlInfoFlash.getDownloadstring_char();
        short len = (short)name.length();
        try {
          memcpy(pu8Temp, offset, name.getBytes(
                System.getProperty("file.encoding")), len);
        } catch (UnsupportedEncodingException unsupportedEncodingException) {}
        offset += len;
      } 
    } else {
      offset = alterU16ToU8(pu8Temp, offset, (short)0);
    } 
    pu8Temp[offset++] = 1;
    offset = alterU16ToU8(pu8Temp, offset, (short)16);
    offset = alterU32ToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash
        .getuFlashType());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash
        .getlFlashIndex());
    if (isIs32Bit()) {
      offset = alterU32ToU8(pu8Temp, offset, 
          
          (int)struDownloadPartitionControlInfoFlash.getuPartitionEndAddr());
    } else {
      offset = alterU64ToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash
          
          .getuPartitionEndAddr());
    } 
    if (is64Bit())
      offset = alterU32LowToU8(pu8Temp, offset, struDownloadPartitionControlInfoFlash


          
          .getPartitionVerifyTag()); 
    int u32CrcVal = Crc32.compute(partitionControl.getSecBufAddr(), 1, totalLength - u32CRClen - 1);
    alterU32ToU8(partitionControl.getSecBufAddr(), totalLength - u32CRClen, u32CrcVal);
  }
  
  private static void fillDownloadControlSecContext(LoaderDownloadControl pstruDownloadControl) {
    int u32TotleLen = 0;
    LoaderDownloadInfo struDownloadInfo = new LoaderDownloadInfo();
    int u32SecHeadLen = 9;
    int u32CrcLen = 4;
    int u32ParLen = 0;
    int u32CrcVal = 0;
    fillDownloadControlSecHead(pstruDownloadControl.getStSecHead());
    fillDownloadControlDownInfo(struDownloadInfo);
    if (is64Bit()) {
      u32ParLen = struDownloadInfo.getDownloadPartInfo()[6] * 18;
      u32ParLen += 10;
    } else if (isIs32Bit()) {
      u32ParLen = struDownloadInfo.getDownloadPartInfo()[6] * 14;
      u32ParLen += 10;
    } else {
      u32ParLen = struDownloadInfo.getDownloadPartInfo()[10] * 14;
      u32ParLen += 14;
    } 
    u32ParLen += struDownloadInfo.getDownloadPartInfo()[u32ParLen] + 1 + 11 + 4;
    u32TotleLen = u32SecHeadLen + struDownloadInfo.getDownloadInfoLen() + u32ParLen + 2 + u32CrcLen;
    pstruDownloadControl.setSecBufAddr(new byte[u32TotleLen]);
    Arrays.fill(pstruDownloadControl.getSecBufAddr(), (byte)0);
    pstruDownloadControl.setSecLen(u32TotleLen);
    pstruDownloadControl.getStSecHead().setSectionLength12((short)(u32TotleLen - 4));
    fillSecHead(pstruDownloadControl.getStSecHead(), pstruDownloadControl
        .getSecBufAddr());
    byte[] pu8Temp = pstruDownloadControl.getSecBufAddr();
    int offset = u32SecHeadLen;
    pu8Temp[offset++] = struDownloadInfo.getDownloadInfoTag();
    pu8Temp[offset++] = struDownloadInfo.getDownloadInfoLen();
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getStbManufacturerId());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getHardwareVer());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getSoftwareVer());
    pu8Temp[offset++] = struDownloadInfo.getDownloadTableId();
    pu8Temp[offset++] = struDownloadInfo.getKeyControl();
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getSerialNumberStart());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getSerialNumberEnd());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getDownloadDate());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getWebBrowserVer());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getKernelVer());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getCaVer());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getBootLoaderVer());
    offset = alterU32ToU8(pu8Temp, offset, struDownloadInfo
        .getLoaderVer());
    pu8Temp[offset++] = struDownloadInfo.getHardwareStringLen();
    System.arraycopy(struDownloadInfo.getHardwareStringDescriptor(), 0, pu8Temp, offset, struDownloadInfo
        .getHardwareStringLen());
    offset += struDownloadInfo.getHardwareStringLen();
    System.arraycopy(struDownloadInfo.getDownloadPartInfo(), 0, pu8Temp, offset, u32ParLen);
    u32CrcVal = Crc32.compute(pstruDownloadControl.getSecBufAddr(), 1, u32TotleLen - u32CrcLen - 1);
    alterU32ToU8(pstruDownloadControl.getSecBufAddr(), u32TotleLen - u32CrcLen, u32CrcVal);
    pstruDownloadControl.setSecLen(u32TotleLen);
  }
  
  private static void memcpy(byte[] pTmp, int offset, String string, long len) {
    if (len > string.length())
      len = string.length(); 
    for (int i = 0; i < len; i++)
      pTmp[offset++] = (byte)string.charAt(i); 
  }
  
  private static List<PartFile> fillFileDataStruct(List<UpgradeFileInfo> files) {
    g_u32DataMagicNum = getRandomU32();
    g_u32DataCrc = -1;
    List<PartFile> headers = new ArrayList<>(files.size());
    for (int i = 0; i < files.size(); i++) {
      PartFile partFile = new PartFile();
      headers.add(partFile);
      partFile.init(files.get(i));
      long fileLength = (new File(partFile.getFileName())).length();
      long lastSectionLength = 992L;
      long sectionNum = fileLength / 992L;
      if (0L != fileLength % 992L) {
        lastSectionLength = fileLength % 992L;
        sectionNum++;
      } 
      long datagramNum = ((sectionNum & 0x8L) == 0L) ? (sectionNum / 8L) : (sectionNum / 8L + 1L);
      partFile.setLastDiagramDataLength(lastSectionLength);
      partFile.setDatagramNum((int)datagramNum);
      partFile.setSectionNum(sectionNum);
      try {
        int[] crc = Crc32.compute(partFile.getFileName(), g_u32DataCrc);
        partFile.setCrcValue(crc[0]);
        g_u32DataCrc = crc[1];
      } catch (IOException iOException) {}
    } 
    return headers;
  }
  
  public IStatus createPackage(List<UpgradeFileInfo> fileInfoList, SsuUpgradeInfo info, SsuPackageOptions packageOtions, String tsFileName, IProgressMonitor monitor) throws IOException, LoaderException {
    return null;
  }
  
  private static void log(String infoStr) {
    if (PropertiesUtility.isCmdLine())
      Log.println(infoStr); 
  }
}
